
//		CharInfo.cpp


#ifndef CHARINFO_VER
#define CHARINFO_VER				1.0.8.1


#ifndef SURROGATE_MASK
#define SURROGATE_MASK				0xf800
#define SURROGATE_TEST_MASK			0xfc00
#define SURROGATE_VALUE_MASK		0x03ff
#define SURROGATE_OFFSET			0x10000
#define HIGH_SURROGATE				0xd800
#define LOW_SURROGATE				0xdc00
#define MAX_CODEPOINT				0x10ffff
#endif	//	SURROGATE_MASK


#define CHARINFO_POPUP_ALPHA		0xf0

#define CHARINFO_DELAYED_CLOSE		0x1492
#define CHARINFO_CHECK_MOVED		0x1493


#include "FindMyWindow.cpp"



const wchar_t CtrlCharName[64][4]		= {
	L"NUL", L"SOH", L"STX", L"ETX", L"EOT", L"ENQ", L"ACK", L"BEL", L"BS",  L"HT",  L"LF",  L"VT",  L"FF",  L"CR",  L"SO",  L"SI",
	L"DLE", L"DC1", L"DC2", L"DC3", L"DC4", L"NAK", L"SYN", L"ETB", L"CAN", L"EM",  L"SUB", L"ESC", L"FS",  L"GS",  L"RS",  L"US",
	L"XXX", L"XXX", L"BPH", L"NBH", L"IND", L"NEL", L"SSA", L"ESA", L"HTS", L"HTJ", L"VTS", L"PLD", L"PLU", L"RI",  L"SS2", L"SS3",
	L"DCS", L"PU1", L"PU2", L"STS", L"CCH", L"MW",  L"SPA", L"EPA", L"SOS", L"XXX", L"SCI", L"CSI", L"ST",  L"OSC", L"PM",  L"APC" };


const wchar_t CharInfo_PopupOffsetX[]	= L"X Offset";
const wchar_t CharInfo_PopupOffsetY[]	= L"Y Offset";
const wchar_t CharInfo_PopupWidth[]		= L"Width";
const wchar_t CharInfo_PopupHeight[]	= L"Height";



//	--------------------  Global Variables  --------------------

typedef unsigned __int32 ( __cdecl *_CharInfo_GetCharNameProc ) ( __int32 code, int nameChoice, char *buffer, unsigned __int32 bufferLength, int *pErrorCode );

HWND CharInfoPopup			= NULL;
HWND CharInfo_MyWindow		= NULL;
int CharInfo_OldMainLeft	= 0;
int CharInfo_OldMainTop		= 0;

HMODULE CharInfo_UnicodeDll							= NULL;
_CharInfo_GetCharNameProc CharInfo_GetCharName		= NULL;


//	------------------------------------------------------------




int CharInfo_SavePopupPos( HWND hWnd, BOOL Nonvolatile )
{
	wchar_t KeyName[SHORT_BUF_LEN]		= L"";

	RECT PopupRect			= { 0, 0, 0, 0 };
	RECT MainWinRect		= { 0, 0, 0, 0 };
	int OffsetX				= 0;
	int OffsetY				= 0;
	unsigned int Width		= 0;
	unsigned int Height		= 0;

	HKEY PluginKeyHandle	= NULL;
	HKEY KeyHandle			= NULL;

	int errors				= 0;
	int rv					= 0;


	if ( !CharInfo_MyWindow )
		return 0;

	if ( !GetWindowRect( hWnd, &PopupRect ) || !GetWindowRect( CharInfo_MyWindow, &MainWinRect ) )
		return 0;

	OffsetX	= PopupRect.left - MainWinRect.left;
	OffsetY	= PopupRect.top - MainWinRect.top;
	Width	= PopupRect.right - PopupRect.left;
	Height	= PopupRect.bottom - PopupRect.top;


	if ( RegCreateKeyEx( HKEY_CURRENT_USER, PluginRegKey, 0, NULL, 0, KEY_READ | KEY_WRITE, NULL, &PluginKeyHandle, NULL ) == ERROR_SUCCESS ) {

		wsprintf( KeyName, L"CharInfo Popup %04X", GetConsoleWindow() );

		if ( RegCreateKeyEx( PluginKeyHandle, KeyName, 0, NULL, REG_OPTION_VOLATILE, KEY_READ | KEY_WRITE, NULL, &KeyHandle, NULL ) == ERROR_SUCCESS ) {
			errors = 0;

			if ( RegSetValueEx( KeyHandle, CharInfo_PopupOffsetX, 0, REG_DWORD, (BYTE*) &OffsetX, sizeof( DWORD ) ) )
				errors++;

			if ( RegSetValueEx( KeyHandle, CharInfo_PopupOffsetY, 0, REG_DWORD, (BYTE*) &OffsetY, sizeof( DWORD ) ) )
				errors++;

			if ( RegSetValueEx( KeyHandle, CharInfo_PopupWidth, 0, REG_DWORD, (BYTE*) &Width, sizeof( DWORD ) ) )
				errors++;

			if ( RegSetValueEx( KeyHandle, CharInfo_PopupHeight, 0, REG_DWORD, (BYTE*) &Height, sizeof( DWORD ) ) )
				errors++;

			if ( !errors )
				rv++;

			RegCloseKey( KeyHandle );
			KeyHandle = NULL;
		}

		if ( Nonvolatile ) {
			if ( RegCreateKeyEx( PluginKeyHandle, L"CharInfo Popup", 0, NULL, 0, KEY_READ | KEY_WRITE, NULL, &KeyHandle, NULL ) == ERROR_SUCCESS ) {
				errors = 0;

				if ( RegSetValueEx( KeyHandle, CharInfo_PopupOffsetX, 0, REG_DWORD, (BYTE*) &OffsetX, sizeof( DWORD ) ) )
					errors++;

				if ( RegSetValueEx( KeyHandle, CharInfo_PopupOffsetY, 0, REG_DWORD, (BYTE*) &OffsetY, sizeof( DWORD ) ) )
					errors++;

				if ( RegSetValueEx( KeyHandle, CharInfo_PopupWidth, 0, REG_DWORD, (BYTE*) &Width, sizeof( DWORD ) ) )
					errors++;

				if ( RegSetValueEx( KeyHandle, CharInfo_PopupHeight, 0, REG_DWORD, (BYTE*) &Height, sizeof( DWORD ) ) )
					errors++;

				if ( !errors )
					rv++;

				RegCloseKey( KeyHandle );
				KeyHandle = NULL;
			}
		}

		RegCloseKey( PluginKeyHandle );
	}

	return rv;
}



int CharInfo_RestorePopupPos( HWND hWnd )
{
	wchar_t KeyName[SHORT_BUF_LEN]		= L"";

	RECT MainWinRect		= { 0, 0, 0, 0 };
	RECT PopupRect			= { 0, 0, 0, 0 };
	int OffsetX				= 0;
	int OffsetY				= 0;
	unsigned int Width		= 0;
	unsigned int Height		= 0;


	HKEY KeyHandle			= NULL;
	DWORD ValType			= 0;
	DWORD ValSize			= 0;

	int errors				= 0;
	int rv					= 0;


	if ( !CharInfo_MyWindow )
		return 0;

	if ( !GetWindowRect( CharInfo_MyWindow, &MainWinRect ) )
		return 0;


	wsprintf( KeyName, L"%s\\CharInfo Popup %04X", PluginRegKey, GetConsoleWindow() );


	if ( RegOpenKeyEx( HKEY_CURRENT_USER, KeyName, 0, KEY_READ, &KeyHandle ) == ERROR_SUCCESS ) {

		ValType = 0;
		ValSize = sizeof( DWORD );

		if ( RegQueryValueEx( KeyHandle, CharInfo_PopupOffsetX, NULL, &ValType, (BYTE*) &OffsetX, &ValSize ) )
			errors++;
		else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
			errors++;

		ValType = 0;
		ValSize = sizeof( DWORD );

		if ( RegQueryValueEx( KeyHandle, CharInfo_PopupOffsetY, NULL, &ValType, (BYTE*) &OffsetY, &ValSize ) )
			errors++;
		else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
			errors++;

		ValType = 0;
		ValSize = sizeof( DWORD );

		if ( RegQueryValueEx( KeyHandle, CharInfo_PopupWidth, NULL, &ValType, (BYTE*) &Width, &ValSize ) )
			errors++;
		else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
			errors++;

		ValType = 0;
		ValSize = sizeof( DWORD );

		if ( RegQueryValueEx( KeyHandle, CharInfo_PopupHeight, NULL, &ValType, (BYTE*) &Height, &ValSize ) )
			errors++;
		else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
			errors++;

		if ( !errors ) {
			PopupRect.left		= MainWinRect.left + OffsetX;
			PopupRect.top		= MainWinRect.top + OffsetY;
			PopupRect.right		= PopupRect.left + Width;
			PopupRect.bottom	= PopupRect.top + Height;

			if ( MonitorFromRect( &PopupRect, MONITOR_DEFAULTTONULL ) )
				if ( SetWindowPos( hWnd, HWND_TOP, PopupRect.left, PopupRect.top, Width, Height, SWP_SHOWWINDOW ) )
					rv = 1;
		}

		RegCloseKey( KeyHandle );
	}


	if ( !rv ) {
		wsprintf( KeyName, L"%s\\CharInfo Popup", PluginRegKey );

		if ( RegOpenKeyEx( HKEY_CURRENT_USER, KeyName, 0, KEY_READ, &KeyHandle ) == ERROR_SUCCESS ) {

			ValType = 0;
			ValSize = sizeof( DWORD );

			if ( RegQueryValueEx( KeyHandle, CharInfo_PopupOffsetX, NULL, &ValType, (BYTE*) &OffsetX, &ValSize ) )
				errors++;
			else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
				errors++;

			ValType = 0;
			ValSize = sizeof( DWORD );

			if ( RegQueryValueEx( KeyHandle, CharInfo_PopupOffsetY, NULL, &ValType, (BYTE*) &OffsetY, &ValSize ) )
				errors++;
			else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
				errors++;

			ValType = 0;
			ValSize = sizeof( DWORD );

			if ( RegQueryValueEx( KeyHandle, CharInfo_PopupWidth, NULL, &ValType, (BYTE*) &Width, &ValSize ) )
				errors++;
			else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
				errors++;

			ValType = 0;
			ValSize = sizeof( DWORD );

			if ( RegQueryValueEx( KeyHandle, CharInfo_PopupHeight, NULL, &ValType, (BYTE*) &Height, &ValSize ) )
				errors++;
			else if ( ( ValType != REG_DWORD ) || ( ValSize != sizeof( DWORD ) ) )
				errors++;

			if ( !errors ) {
				PopupRect.left		= MainWinRect.left + OffsetX;
				PopupRect.top		= MainWinRect.top + OffsetY;
				PopupRect.right		= PopupRect.left + Width;
				PopupRect.bottom	= PopupRect.top + Height;

				if ( MonitorFromRect( &PopupRect, MONITOR_DEFAULTTONULL ) )
					if ( SetWindowPos( hWnd, HWND_TOP, PopupRect.left, PopupRect.top, Width, Height, SWP_SHOWWINDOW ) )
						rv = 1;
			}

			RegCloseKey( KeyHandle );
		}
	}


	return rv;
}



int CharInfo_DefaultPopupPos( HWND hWnd )
{
	RECT PopupRect			= { 0, 0, 0, 0 };
	RECT MainWinRect		= { 0, 0, 0, 0 };

	int rv					= 0;


	if ( !CharInfo_MyWindow )
		return 0;

	if ( !GetWindowRect( hWnd, &PopupRect ) || !GetWindowRect( CharInfo_MyWindow, &MainWinRect ) )
		return 0;


	if ( SetWindowPos( hWnd, HWND_TOP, MainWinRect.right - ( PopupRect.right - PopupRect.left ) - GetSystemMetrics( SM_CXVSCROLL ) - 10, MainWinRect.top + GetSystemMetrics( SM_CYCAPTION ) + 15, 0, 0, SWP_SHOWWINDOW | SWP_NOSIZE ) )
		rv = 1;

	return rv;
}



INT_PTR CALLBACK CharInfoDialogProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch ( uMsg ) {

	case WM_INITDIALOG :

		SetTimer( hWnd, CHARINFO_CHECK_MOVED, 300, NULL );
		break;

	case WM_COMMAND :

		if ( LOWORD( wParam ) == IDCANCEL ) {
			DestroyWindow( hWnd );
			return TRUE;
		}

		return TRUE;

	case WM_DESTROY :

		KillTimer( hWnd, CHARINFO_CHECK_MOVED );
		KillTimer( hWnd, CHARINFO_DELAYED_CLOSE );
		CharInfo_SavePopupPos( hWnd, ( GetAsyncKeyState( VK_SHIFT ) & 0x8000 ) && ( GetAsyncKeyState( VK_CONTROL ) & 0x8000 )  );
		PostQuitMessage( 0 );
		CharInfoPopup = NULL;
		break;

	case WM_SETFOCUS :

		if ( ( GetAsyncKeyState( VK_SHIFT ) & 0x8000 ) == 0 )
			SetForegroundWindow( CharInfo_MyWindow );

		break;

	case WM_SETCURSOR :

		if ( (HWND) wParam == hWnd ) {
			if ( ( HIWORD( lParam ) == WM_LBUTTONDOWN ) && ( LOWORD( lParam ) == HTCLOSE ) ) {
				SetTimer( hWnd, CHARINFO_DELAYED_CLOSE, 100, NULL );		//	DestroyWindow( hWnd );
				return TRUE;
			}
		}

		break;

	case WM_TIMER :

		if ( wParam == CHARINFO_DELAYED_CLOSE )
			DestroyWindow( hWnd );
		else if ( wParam == CHARINFO_CHECK_MOVED ) {
			RECT PopupRect		= { 0, 0, 0, 0 };
			RECT MainRect		= { 0, 0, 0, 0 };

			if ( GetWindowRect( hWnd, &PopupRect ) && GetWindowRect( CharInfo_MyWindow, &MainRect ) ) {
				if ( ( MainRect.left != CharInfo_OldMainLeft ) || ( MainRect.top != CharInfo_OldMainTop ) ) {
					int OffsetX		= PopupRect.left	- CharInfo_OldMainLeft;
					int OffsetY		= PopupRect.top		- CharInfo_OldMainTop;
					int NewLeft		= MainRect.left	+ OffsetX;
					int NewTop		= MainRect.top	+ OffsetY;

					SetWindowPos( hWnd, HWND_TOP, NewLeft, NewTop, 0, 0, SWP_SHOWWINDOW | SWP_NOSIZE );

					CharInfo_OldMainLeft	= MainRect.left;
					CharInfo_OldMainTop		= MainRect.top;
				}
			}
		}

		break;
	}

	return FALSE;
}



int OpenCharInfoPopup( BYTE Alpha, LPCTSTR Text )
{
	HWND ForegroundWindow		= GetForegroundWindow();
	RECT MainWindowRect			= { 0, 0, 0, 0 };


	if ( CharInfoPopup == NULL ) {
		CharInfo_MyWindow = FindMyWindow();

		if ( CharInfo_MyWindow ) {
			if ( GetWindowRect( CharInfo_MyWindow, &MainWindowRect ) ) {
				CharInfo_OldMainLeft	= MainWindowRect.left;
				CharInfo_OldMainTop		= MainWindowRect.top;
			}
		}

		CharInfoPopup = CreateDialog( MyDLLHandle, MAKEINTRESOURCE( IDD_DIALOG1 ), CharInfo_MyWindow, CharInfoDialogProc );

		if ( !CharInfoPopup )
			return 0;

		SendMessage( CharInfoPopup, WM_SETICON, NULL, NULL );
		SetLayeredWindowAttributes( CharInfoPopup, 0, Alpha, LWA_ALPHA );

		if ( Text )
			SetDlgItemText( CharInfoPopup, IDC_STATIC, Text );

		if ( IsWindowVisible( CharInfo_MyWindow ) )
			if ( !CharInfo_RestorePopupPos( CharInfoPopup ) )
				CharInfo_DefaultPopupPos( CharInfoPopup );
	}
	else if ( Text )
		SetDlgItemText( CharInfoPopup, IDC_STATIC, Text );

	SetForegroundWindow( ForegroundWindow );
	return 1;
}



int ShowCharInfo( KEYINFO24 *ki )
{
	if ( !ki )
		goto Error;
	else if ( ki->pszLine == NULL )
		goto Error;
	else if ( ki->pszLine[0] == '\0' )
		goto Error;


	wchar_t temp[SHORT_BUF_LEN]				= L"";

	wchar_t CharBuf[20]						= L"";
	wchar_t Utf8Encoding[SHORT_BUF_LEN]		= L"";
	char CharName[66]						= "";
	int ErrorCode							= 0;


	size_t Cursor			= ki->pszCurrent - ki->pszLine;
	size_t len				= wcslen( ki->pszLine );
	size_t index			= Cursor;
	int ch					= 0;
	int rv					= 0;



	if ( index >= len )
		index = len - 1;

	ch = ki->pszLine[index];

	if ( ( ( ch & SURROGATE_TEST_MASK ) == HIGH_SURROGATE ) && ( index < ( len - 1 ) ) )
		if ( ( ki->pszLine[index + 1] & SURROGATE_TEST_MASK ) == LOW_SURROGATE )
			ch = ( ( ( ki->pszLine[index] & SURROGATE_VALUE_MASK ) << 10 ) | ( ki->pszLine[index + 1] & SURROGATE_VALUE_MASK ) ) + SURROGATE_OFFSET;

	if ( ( ( ch & SURROGATE_TEST_MASK ) == LOW_SURROGATE ) && index )
		if ( ( ki->pszLine[index - 1] & SURROGATE_TEST_MASK ) == HIGH_SURROGATE )
			ch = ( ( ( ki->pszLine[index - 1] & SURROGATE_VALUE_MASK ) << 10 ) | ( ki->pszLine[index] & SURROGATE_VALUE_MASK ) ) + SURROGATE_OFFSET;

	
	if ( ch < 0x20 )
		wsprintf( CharBuf, L"^%c  (%s)", ch + 0x40, CtrlCharName[ch] );
	else if ( ch == 0x7f )
		wcscpy_s( CharBuf, SHORT_BUF_LEN, L"DEL" );
	else if ( ( ch >= 0x80 ) && ( ch < 0xa0 ) )
		wcscpy_s( CharBuf, SHORT_BUF_LEN, CtrlCharName[ch - 0x60] );
	else if ( ch >= SURROGATE_OFFSET ) {
		wchar_t h	= ( ( ch - SURROGATE_OFFSET ) >> 10 ) | HIGH_SURROGATE;
		wchar_t l	= ( ( ch - SURROGATE_OFFSET ) & SURROGATE_VALUE_MASK ) | LOW_SURROGATE;

		wsprintf( CharBuf, L"%c%c", h, l );
	}
	else if ( ch == 0xa0 )
		wcscpy_s( CharBuf, SHORT_BUF_LEN, L"NBSP" );
	else if ( ch == 0xad )
		wcscpy_s( CharBuf, SHORT_BUF_LEN, L"SHY" );
	else if ( ch == 0xfeff )
		wcscpy_s( CharBuf, SHORT_BUF_LEN, L"BOM" );
	else
		wsprintf( CharBuf, L"%c", ch );


	if ( ch < 0x0080 )
		wsprintf( Utf8Encoding, L"%02X", ch );
	else if ( ch < 0x0800 )
		wsprintf( Utf8Encoding, L"%02X %02X", ( ch >> 6 ) | 0xc0, ( ch & 0x3f ) | 0x80 );
	else if ( ch < 0x10000 )
		wsprintf( Utf8Encoding, L"%02X %02X %02X", ( ch >> 12 ) | 0xe0, ( ( ch >> 6 ) & 0x3f ) | 0x80, ( ch & 0x3f ) | 0x80 );
	else if ( ch <= MAX_CODEPOINT )
		wsprintf( Utf8Encoding, L"%02X %02X %02X %02X", ( ch >> 18 ) | 0xf0, ( ( ch >> 12 ) & 0x3f ) | 0x80, ( ( ch >> 6 ) & 0x3f ) | 0x80, ( ch & 0x3f ) | 0x80 );


	wsprintf( temp, L"[\u200a%s\u200a] \u2001\u2001U+%04X   (%d decimal) \u2001\u2001UTF-8: %s", CharBuf, ch, ch, Utf8Encoding );
	
	if ( ch >= 0x10000 )
		wsprintf( temp + wcslen( temp ), L" \u2001\u2001UTF-16: %04X %04X", CharBuf[0], CharBuf[1] );

	if ( CharInfo_GetCharName ) {
		CharInfo_GetCharName( ch, 0, CharName, 64, &ErrorCode );

		if ( CharName[0] )
			wsprintf( temp + wcslen( temp ), L" \u2001\u2001%S", CharName );		
	}


	rv = TakeCommandIPC( L"STATUSBAR", temp );
	
	if ( rv ) {
		wsprintf( temp, L"Character: \t%s\n\nValue: \t\tU+%04X  (%d decimal)\nUTF-8: \t\t%s\n", CharBuf, ch, ch, Utf8Encoding );

		if ( ch >= 0x10000 )
			wsprintf( temp + wcslen( temp ), L"UTF-16: \t%04X %04X\n", CharBuf[0], CharBuf[1] );

		if ( CharName[0] )
			wsprintf( temp + wcslen( temp ), L"\n%S\n", CharName );		
		
		if ( !OpenCharInfoPopup( CHARINFO_POPUP_ALPHA, temp ) )
			MessageBox( GetConsoleWindow(), temp, L"Character Info", MB_OK | MB_SETFOREGROUND );
	}
	else if ( CharInfoPopup ) {
		DestroyWindow( CharInfoPopup );
		CharInfoPopup = NULL;
	}


	ki->nKey = 0;
	if ( NewKeyHook )
		ki->pszKey[0] = '\0';

	return 0;

Error:

	ErrorBeep();

	ki->nKey = 0;
	if ( NewKeyHook )
		ki->pszKey[0] = '\0';

	return 0;
}



int CharInfo_ClosePopup()
{
	if ( CharInfoPopup ) {
		DestroyWindow( CharInfoPopup );
		CharInfoPopup = NULL;
	}

	return 0;
}



HMODULE CharInfo_LoadUnicodeDll()
{
	wchar_t Filename[MAX_FILENAME_LEN]		= L"";

	size_t len								= 0;
	HMODULE LibHandle						= NULL;


	GetSystemDirectory( Filename, MAX_FILENAME_LEN );
	if ( Filename[0] )
		AppendFilename( Filename, L"", MAX_FILENAME_LEN );

	len = wcslen( Filename );

	wcscat_s( Filename, MAX_FILENAME_LEN, L"icu.dll" );
	if ( LibHandle = LoadLibrary( Filename ) )
		return LibHandle;

	Filename[len] = '\0';

	wcscat_s( Filename, MAX_FILENAME_LEN, L"icuuc.dll" );
	if ( LibHandle = LoadLibrary( Filename ) )
		return LibHandle;

	return NULL;
}



int CharInfo_Initialize()
{
	if ( CharInfo_UnicodeDll = CharInfo_LoadUnicodeDll() )
		CharInfo_GetCharName = (_CharInfo_GetCharNameProc) GetProcAddress( CharInfo_UnicodeDll, "u_charName" );
	
	return 0;
}



int CharInfo_Shutdown()
{
	CharInfo_ClosePopup();

	if ( CharInfo_UnicodeDll )
		FreeLibrary( CharInfo_UnicodeDll );

	return 0;
}


#endif	//	CHARINFO_VER


/*

		1.0.0.0		2022-05-13

		1.0.1.0		2022-06-14
					Adds a popup dialog box for use in regular console windows.

		1.0.2.0		2022-06-17
					Added CharInfo_ClosePopup() (which at this time does exactly the
					same thing as CharInfo_Shutdown(). )

		1.0.3.0		2022-06-17
					Reworked OpenCharInfoPopup(); now it takes Alpha and Text
					parameters.

		1.0.4.0		2022-06-22
					Added names for C0 and C1 control characters, plus NBSP and SHY.

		1.0.4.1		2022-06-24
					Added BOM to character names.

		1.0.4.2		2022-07-15
					Removed the iswprint() test.  It fails for the Euro sign, and who
					knows what all else.

		1.0.5.0		2022-07-19
					Now the dialog relies on WM_SETFOCUS instead of a timer procedure
					to shrug off focus.  This should make it work better with Console2,
					Windows Terminal, etc.

		1.0.6.0		2022-07-19
					Save and restore the position of the popup window relative to the
					console window.

		1.0.6.1		2022-07-19
					SetTimer() was missing a matching KillTimer(); fixed.

		1.0.7.0		2022-07-19
					Checks for the console window being moved from underneath the
					popup dialog.

		1.0.7.1		2022-08-11
					Accommodate changes in FindMyWindow.cpp.

		1.0.8.0		2024-03-15
					Added the ability to look up character names.

		1.0.8.1		2024-03-15
					Fixed the above to correctly handle characters outside the BMP.
					Changed the order of the fields in TCmd's status bar.

*/
