
//			QuoteWord.cpp


#ifndef QUOTE_WORD_VER
#define QUOTE_WORD_VER			1.0.0.0



int QuoteWord( KEYINFO24 *ki )
{
	wchar_t Word[MAX_ARG_LEN]		= L"";

	size_t WordStart			= 0;
	size_t WordLen				= 0;


	ki->nKey = 0;
	if ( NewKeyHook )
		ki->pszKey[0] = '\0';


	if ( !FindWordAtCursor( ki, &WordStart, &WordLen, Word, MAX_ARG_LEN ) ) {
		ErrorBeep();
		return 0;
	}


	if ( ki->pszLine[WordStart] == QUOTE ) {
		StripQuotes( Word );
		CmdLineDelete( ki, WordStart, WordLen );
		CmdLineInsert( ki, Word, WordStart );
	}
	else {
		CmdLineInsert( ki, L"\"", WordStart );

		if ( !wcschr( ki->pszLine + WordStart + 1, QUOTE ) ) {
			size_t lp	= 0;

			for ( size_t i = WordStart + 1; ki->pszLine[i]; i++ )
				if ( !iswspace( ki->pszLine[i] ) )
					lp = i;

			if ( lp ) {
				CmdLineInsert( ki, L"\"", lp + 1 );
				ki->pszCurrent = ki->pszLine + lp + 2;
			}
		}
	}

	return 0;
}


#endif	//	QUOTE_WORD_VER


/*

	1.0.0.0		2022-06-29

*/
